/*
 * ASTRI - Template based on ALMA Software Templates
 * (c) INAF/UNIPG, 2014 
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY, without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307  USA
 *
 * WARNING! DO NOT MODIFY THIS FILE!
 *  ---------------------------------------------------------
 * | This is generated code!  Do not modify this file.       |
 * | Any changes will be lost when the file is re-generated. |
 *  ---------------------------------------------------------
 *
 *  Generated by: $Author
 *  Date: $Date
 *  Description: $Description
 *
 */
 
\#ifndef ${Assembly}Base_idl
\#define ${Assembly}Base_idl

// External interface to the hardware assembly: TCS::$Assembly

\#include <enumpropMACRO.idl>
\#include <ACSErrTypeCommon.idl>
\#include <enumpropStd.idl>
\#include <TCSHardwareDevice.idl>
\#include <TCSControlExceptions.idl>
\#include <baci.idl>

\#pragma prefix "astri"

#silent L=[]

module TCS {
  // $Description 
  interface ${Assembly}Base:TCS::TCSHardwareDevice {

    // BACI Properties

  #if $x.GetSheet["NRows"]>=1 
	#for $idx in $range(0,$x.GetSheet["NRows"])
	 #silent L.append($x.GetSheet["Short name"][$idx])
      
      #if ($x.GetSheet["OPC UA Data type"][$idx].upper())[0]=='A'
         #set $dd=($x.GetSheet["OPC UA Data type"][$idx].upper()).split('[')[0]
         ##pip = $dd
         readonly attribute ACS::RO${y[$dd][0]} $x.GetSheet["Short name"][$idx];
      #else
	   readonly attribute ACS::RO${y[$x.GetSheet["OPC UA Data type"][$idx].upper()][0]} $x.GetSheet["Short name"][$idx];
      #end if
	#end for
  #end if
  
  #if $x.SetSheet["NRows"]>=1 
    #for $idx in $range(0,$x.SetSheet["NRows"])
    #silent L.append($x.SetSheet["Short name"][$idx])
    readonly attribute ACS::RW${y[$x.SetSheet["OPC UA Data type"][$idx].upper()][0]} $x.SetSheet["Short name"][$idx];
    #end for
  #end if
  
  #if $x.ModeSheet["NRows"]>=1 
  #for $idx in $range(0,$x.ModeSheet["NRows"])
	#set $name=($x.ModeSheet["OPC_UA node"][$idx].split(";")[1]).split("=")[1].replace(".","_")
	#if not $name in L
    readonly attribute ACS::RW${y[$x.ModeSheet["OPC UA Data type"][$idx].upper()][0]} $name;
    #silent L.append($name)
    #end if
  #end for
  #end if
  
  #if $x.CmdSheet["NRows"]>=1 
  #for $idx in $range(0,$x.CmdSheet["NRows"])
	#set $name=($x.CmdSheet["OPC_UA node"][$idx].split(";")[1]).split("=")[1].replace(".","_")
	#if not $name in L
    readonly attribute ACS::RW${y[$x.CmdSheet["OPC UA Data type"][$idx].upper()][0]} $name;
    #silent L.append($name)
    #end if
  #end for
  #end if
  
    // GET commands
#*        
  #for $idx in $range(0,$x.GetSheet["NRows"])
	// $x.GetSheet["Description"][$idx].replace('\n', '')
	#if $y[$x.GetSheet["OPC UA Data type"][$idx].upper()][0] =='Bool'
	ACS::Bool $x.GetSheet["Name of command"][$idx] (out ACS::Time timestamp) raises (TCSControlExceptions::OPCUAErrorEx, TCSControlExceptions::INACTErrorEx);
	#else
    ${y[$x.GetSheet["OPC UA Data type"][$idx].upper()][0]} $x.GetSheet["Name of command"][$idx] (out ACS::Time timestamp) raises (TCSControlExceptions::OPCUAErrorEx, TCSControlExceptions::INACTErrorEx);
    #end if
        
  #end for

    // SET commands
        
  #for $idx in $range(0,$x.SetSheet["NRows"])
	// $x.SetSheet["Description"][$idx].replace('\n', '')
	#if $y[$x.SetSheet["OPC UA Data type"][$idx].upper()][0] =='Bool'
	ACS::Bool G${x.SetSheet["Name of command"][$idx][1:]}(out ACS::Time timestamp) raises (TCSControlExceptions::OPCUAErrorEx, TCSControlExceptions::INACTErrorEx);
	#else
    ${y[$x.SetSheet["OPC UA Data type"][$idx].upper()][0]} G${x.SetSheet["Name of command"][$idx][1:]}(out ACS::Time timestamp) raises (TCSControlExceptions::OPCUAErrorEx, TCSControlExceptions::INACTErrorEx);
    #end if
	void ${x.SetSheet["Name of command"][$idx]}(in ${y[$x.SetSheet["OPC UA Data type"][$idx].upper()][0]} world)  raises(TCSControlExceptions::INACTErrorEx,
               TCSControlExceptions::IllegalParameterErrorEx);
                   
  #end for

    // MODE commands
        
  #for $idx in $range(0,$x.ModeSheet["NRows"])
	// $x.ModeSheet["Description"][$idx].replace('\n', '')
    void ${x.ModeSheet["Name of command"][$idx]}() raises (TCSControlExceptions::INACTErrorEx,
               TCSControlExceptions::IllegalParameterErrorEx);
                   
  #end for
  
    // CMD commands
        
  #for $idx in $range(0,$x.CmdSheet["NRows"])
	// $x.CmdSheet["Description"][$idx].replace('\n', '')
    void ${x.CmdSheet["Name of command"][$idx]}() raises (TCSControlExceptions::INACTErrorEx,
               TCSControlExceptions::IllegalParameterErrorEx);
                   
  #end for
*#
    };
};
\#endif

